<template>
  <a-page-header :title="title" @back="() => $router.go(-1)">
    <div class="ele-cell ele-cell-align-top">
      <!-- 设计画布 -->
      <div class="body ele-cell-content ele-bg-white" style="display: ">
        <a-card :bordered="false" :body-style="{ padding: '16px' }">
          <ele-pro-table
            ref="tableRef"
            row-key="menuId"
            :columns="columns"
            :datasource="datasource"
            :customRow="customRow"
            tool-class="ele-toolbar-form"
            class="sys-org-table"
          >
            <template #toolbar>
              <search
                @search="reload"
                :selection="selection"
                @add="openEdit"
                @remove="removeBatch"
                @batchMove="openMove"
              />
            </template>
            <template #footer>
              <div class="ele-text-secondary"
                >温馨提示：选图标可以上<a
                  href="https://www.iconfont.cn"
                  target="_blank"
                  >阿里巴巴矢量图标库</a
                >，修改完后需要<a @click="clearSiteInfoCache">清除缓存</a
                >才会生效</div
              >
            </template>
            <template #bodyCell="{ column, record }">
              <template v-if="column.key === 'icon'">
                <a-avatar :src="record.icon" :width="50" />
              </template>
              <template v-if="column.key === 'path'">
                <span class="ele-text-placeholder">{{ record.path }}</span>
              </template>
              <template v-if="column.key === 'component'">
                <span class="ele-text-placeholder">{{ record.component }}</span>
              </template>
              <template v-if="column.key === 'status'">
                <a-tag v-if="record.status === 0" color="green">显示</a-tag>
                <a-tag v-if="record.status === 1" color="red">隐藏</a-tag>
              </template>
              <template v-if="column.key === 'action'">
                <a-space>
                  <a @click="openEdit(record)">修改</a>
                  <a-divider type="vertical" />
                  <a-popconfirm
                    title="确定要删除此记录吗？"
                    @confirm="remove(record)"
                  >
                    <a class="ele-text-danger">删除</a>
                  </a-popconfirm>
                </a-space>
              </template>
            </template>
          </ele-pro-table>
        </a-card>
      </div>
      <!-- 载入模拟器 -->
      <Simulator :form="form" :type="type" :refresh="refresh" @done="reload" />
      <!-- 中间间隙 -->
      <div style="width: 500px"></div>
      <!-- 编辑弹窗 -->
      <MpMenuEdit
        v-model:visible="showEdit"
        :type="type"
        :data="current"
        @done="reload"
      />
    </div>
  </a-page-header>
</template>

<script lang="ts" setup>
  import { createVNode, ref, unref, watch } from 'vue';
  import { message, Modal } from 'ant-design-vue';
  import { ExclamationCircleOutlined } from '@ant-design/icons-vue';
  import type { EleProTable } from 'ele-admin-pro';
  import type {
    DatasourceFunction,
    ColumnItem
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import Search from './components/search.vue';
  import MpMenuEdit from './components/mpMenuEdit.vue';
  import Simulator from './components/simulator.vue';
  import {
    pageMpMenu,
    removeMpMenu,
    removeBatchMpMenu
  } from '@/api/cms/mp-menu';
  import type { MpMenu, MpMenuParam } from '@/api/cms/mp-menu/model';
  import { getPageTitle, openUrl } from '@/utils/common';
  import { removeSiteInfoCache } from '@/api/cms/website';
  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

  // 表格选中数据
  const selection = ref<MpMenu[]>([]);
  // 当前编辑数据
  const current = ref<MpMenu | null>(null);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 是否显示批量移动弹窗
  const showMove = ref(false);
  // 加载状态
  const loading = ref(true);
  // 页面标题
  const title = getPageTitle();
  const type = ref<number>(2);
  const refresh = ref(false);
  // 模拟器的字段
  const form = ref<any>({
    pageName: '首页',
    showOrderCard: true,
    showCarousel: true,
    showMenuCard: true,
    showShopCard: true,
    showTtrainCard: false
  });
  // 菜单列表
  const list = ref<any[]>();

  // 表格数据源
  const datasource: DatasourceFunction = ({
    page,
    limit,
    where,
    orders,
    filters
  }) => {
    if (filters) {
      where.status = filters.status;
    }
    where.type = 2;
    return pageMpMenu({
      ...where,
      ...orders,
      page,
      limit
    });
  };

  // 表格列配置
  const columns = ref<ColumnItem[]>([
    {
      title: 'ID',
      dataIndex: 'menuId',
      key: 'menuId',
      align: 'center',
      width: 90
    },
    {
      title: '菜单图标',
      dataIndex: 'icon',
      key: 'icon',
      align: 'center',
      width: 90
    },
    {
      title: '菜单名称',
      dataIndex: 'title',
      key: 'title',
      align: 'center'
    },
    {
      title: '路由地址',
      dataIndex: 'path',
      key: 'path'
    },
    {
      title: '所在行',
      dataIndex: 'rows',
      key: 'rows',
      align: 'center'
    },
    {
      title: '排序',
      dataIndex: 'sortNumber',
      key: 'sortNumber',
      align: 'center'
    },
    {
      title: '操作',
      key: 'action',
      width: 180,
      fixed: 'right',
      align: 'center',
      hideInSetting: true
    }
  ]);

  /* 搜索 */
  const reload = (where?: MpMenuParam) => {
    type.value = Number(where?.type) || 0;
    refresh.value = !refresh.value;
    selection.value = [];
    tableRef?.value?.reload({ where: where });
  };

  /* 打开编辑弹窗 */
  const openEdit = (row?: MpMenu) => {
    current.value = row ?? null;
    showEdit.value = true;
  };

  /* 打开批量移动弹窗 */
  const openMove = () => {
    showMove.value = true;
  };

  // 清除缓存
  const clearSiteInfoCache = () => {
    removeSiteInfoCache('SiteInfo:' + localStorage.getItem('TenantId')).then(
      (msg) => {
        if (msg) {
          message.success('缓存已更新');
        }
      }
    );
  };

  /* 删除单个 */
  const remove = (row: MpMenu) => {
    const hide = message.loading('请求中..', 0);
    removeMpMenu(row.menuId)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 批量删除 */
  const removeBatch = () => {
    if (!selection.value.length) {
      message.error('请至少选择一条数据');
      return;
    }
    Modal.confirm({
      title: '提示',
      content: '确定要删除选中的记录吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        removeBatchMpMenu(selection.value.map((d) => d.menuId))
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };

  /* 自定义行属性 */
  const customRow = (record: MpMenu) => {
    return {
      // 行点击事件
      onClick: () => {
        // console.log(record);
      },
      // 行双击事件
      onDblclick: () => {
        openEdit(record);
      }
    };
  };
</script>

<script lang="ts">
  export default {
    name: 'MpMenuHome'
  };
</script>

<style lang="less" scoped></style>
